! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
! This example shows how to use the clone
! function.
program example_clone

  use dal
  
  implicit none

  type(DataSetT) set
  type(DataSetT) clonedSet

  set = dataSet("test.dat",CREATE)
  call setAttribute(set,"att1", 10, "mm", "attribute comment" )
  call release(set)

  set = dataSet("test.dat",MODIFY)
  call setAttribute(set,"att1", 10, "mm", "attribute comment" )
  call release(set)


  clonedSet = clone("test.dat","test2.dat",MODIFY)
  call setAttribute(clonedSet,"att2", 10, "mm", "attribute comment" )
  call release(clonedSet)
  
  set = dataSet("test2.dat",READ)
  write(*,*) "att2 = ", int32Attribute( set, "att2" ); 
  call release(set)

end program example_clone
