! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
! This examples show how to use the copyRows subroutine. 
program example_copyrows

  use dal
  
  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ColumnT) col1, col2
  integer(kind=int32), dimension(:), pointer :: i32
  real(kind=single), dimension(:), pointer :: r32
  integer i

  set = dataSet("test.dat",CREATE)
  tab = addTable(set,"some table",10)

  col1 = addColumn(tab,"col1",INTEGER32,units="m",comment="in32 column")
  i32 => int32Data(col1)

  do i=0,4
    i32(i) = 3*i
  end do

  call release( col1)

  col2 = addColumn(tab,"col2",REAL32,units="Dm",comment="real32 column")
  r32 => real32Data(col2)

  do i=0,4
    r32(i) = 0.5*i
  end do

  call release( col2)

  call copyRows( tab, 0, 5, 5 ) ! copy range [0,4] to [5,9]

  i32 => int32Data(col1)
  r32 => real32Data(col2)

  do i = 0, numberOfRows( tab ) - 1
    write(*,*) i32(i), r32(i) 
  end do

  call release(col1)
  call release(col2)

  call release(set)

end program example_copyrows
