! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
! This example shows how the qualifiedName
! interface is used.
program example_qualifiedname

  use dal

  type(DataSetT) :: set
  type(ArrayT) :: arr
  type(TableT) :: tab
  type(ColumnT) :: col
  type(AttributeT) :: att

  set = dataSet("test.dat",create)
  call setAttribute(set,"sbool",.false.,"set bool comment")

  arr = addArray(set,"array",integer32, dimensions=(/ 1,2,3 /))
  call setAttribute(arr,"abool",.true.,"arr bool comment")

  tab = addTable(set,"table",10)
  call setAttribute(tab,"tbool",.false.,"tab bool comment")

  col = addColumn(tab,"column",INT32,units="UNITS",comment="Column")
  call setAttribute(col,"tlmin",1_int32,"int32 unit","col int32 comment")

  write(*,*) "qualified data set name: ", qualifiedName( set ) ! test.dat
  att = attribute( set, "sbool" )
  write(*,*) "qualified data set attribute name: ", qualifiedName( att ) !"test.dat:sbool
  write(*,*) "qualified table name: ", qualifiedName( tab )! test.dat:table
  att = attribute( tab, "tbool" )
  write(*,*) "qualified table attribute name: ", qualifiedName( att ) ! test.dat:table:tbool
  write(*,*) "qualified array name: ", qualifiedName( arr ) ! test.dat:array
  att = attribute( arr, "abool" )
  write(*,*) "qualified array attribute name: ", qualifiedName( att ) ! test.dat:array:abool
  write(*,*) "qualified column name: ", qualifiedName( col ) ! test.dat:table:column
  att = attribute( col, "tlmin" )
  write(*,*) "qualified array attribute name: ", qualifiedName( att ) ! test.dat:table:column:tlmin

  call release(set)

end program example_qualifiedname
