! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
! This example shows how string attributes are used.
! The program creates a dataset containing two string attributes,
! together with a table containing two string attributes.
! The attributes are then accessed, by name, with
! the stringAttribute() function.
! Also, it is shown how to access the attributes by position.
program example_stringattribute
   
  use dal
  use errorhandling
  implicit none
   
  type(DataSetT) set
  type(TableT) tab
  type(AttributeT) att
  integer i

  set = dataSet("test.dat",CREATE)
  call setAttribute(set,"string1","abcdef","string comment")
  call setAttribute(set,"string2","ghijkl","string comment")
   
  tab = addTable(set,"table",10);
  call setAttribute(tab,"string1","abcdef","string comment")
  call setAttribute(tab,"string2","ghijkl","string comment")

  write(*,*) stringAttribute( set, "string1" ) ! output 'abcdef
  write(*,*) stringAttribute( set, "string2" ) ! output 'ghijkl'
  write(*,*) stringAttribute( tab, "string1" ) ! output 'abcdef
  write(*,*) stringAttribute( tab, "string2" ) ! output 'ghijkl'

  do i = 0, numberOfAttributes( set ) - 1
  	att = attribute( set, i )
	write(*,*) stringAttribute( att ) ! output the sequence 'abcdef', 'ghijkl'
  end do

  call release(set)
   
end program example_stringattribute
