// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#include <string>

typedef short int16;
typedef double real64;

template<class T> sqr(const T& a) { return a*a; }

class DataSet;
class Table;
class Column;
class ColumnData;

class Dal {

  public:

    enum AccessMode { Read, Modify, Create };
};

class DataServer : public Dal {

  public:

    DataSet* open(const std::string&, AccessMode);
};

class DataSet : public Dal {

  public:

    Table* table(const std::string&, AccessMode);
};

class Table : public Dal {

  public:

    Column* column(const std::string&, AccessMode);

    unsigned long count() const;

    bool next();

    void seek(unsigned long from, unsigned long count);
};

class Column : public Dal {

  public:

    ColumnData* data();
};

class ColumnData {

  public:

    int16* int16Data();
    real64* real64Data();
};

class TableProcessor {

  public:

    void process(Table*);
};

extern DataServer *dataSetServer;
