// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
typedef short int16;
typedef double real64;

typedef int DataSet;
typedef int Table; 
typedef int Column;

typedef int ColumnData;

typedef enum { READ, MODIFY, CREATE } AccessMode;

double sqr(double a) { return a*a; }

DataSet*	dataSet(char*,AccessMode);
void		dataSetRelease();

Table*		table(DataSet*,char*,AccessMode);
Column*		column(Table*,char*,AccessMode);

int16*		int16Data(ColumnData*);
real64*		real64Data(ColumnData*);

void		forEachSubTable(Table*,void (*proc)(Table*));

unsigned long	tableCount(Table*);

int		tableNext(Table*);
void		tableSeek(Table*, unsigned long, unsigned long);
void		tableRelease(Table*);
