/* ESA (C) 2000-2018 
*
* This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
*
*    SAS is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    SAS is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with SAS.  If not, see <http:*www.gnu.org/licenses/>.
*/
#include <dal.h>
#include <stdio.h>
#include <math.h>

int main()
{
  DataSet *set;
  Table *tab;
  Column *xCol, *yCol, *rCol;

  set = dataSet("test.dat",MODIFY);
  tab = table(set,"events",MODIFY);
  xCol = column(tab,"x",READ);
  yCol = column(tab,"y",READ);
  rCol = column(tab,"r",CREATE);

  while (tableNext(tab)) {
    unsigned int i;
    int16 *x, *y;
    real64 *r;

    x = int16Data(xCol);
    y = int16Data(yCol);
    r = real64Data(rCol);

    for (i = 0; i < tableCount(tab); ++i) {
      printf("%hd %hd\n", x[i], y[i]);
      r[i] = sqrt( sqr(x[i]) + sqr(y[i]) );
    }
  }

  dataSetRelease(set);

  return 0;
}

