// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*************************************************************** 
* 
* DalCellData.h            & XMM Science Analysis System (SAS) 
* 
* Class representing DAL Cell Data.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalCellData.h,v 1.2 2004/03/05 14:43:01 eojero Exp $
* 
*****************************************************************/ 
#ifndef DAL_CELL_DATA_H
#define DAL_CELL_DATA_H


#include <Dal.h>

#include "DalSeekable.h"
#include "DalChild.h"


class DalCellData : public virtual CellData, public DalSeekable<unsigned long>, public DalChild<Column>
{
	public :

		DalCellData(
			const Column *			parent,
			unsigned long			rowNumber,
			unsigned long			from,
			unsigned long			count );

		virtual ~DalCellData(){}
	protected :

		unsigned long	_rowNumber;

};


#endif


