// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*************************************************************** 
* 
* DalNullable.h          & XMM Science Analysis System (SAS) 
* 
* Class representing a null value.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalNullable.h,v 1.2 2004/03/05 14:43:01 eojero Exp $
* 
*****************************************************************/ 
#ifndef NULLABLE_H
#define NULLABLE_H


#include "Dal.h"


class Nvalue;

class DalNullable : public virtual Nullable
{
	public :

		DalNullable( NullType nullType );
		virtual ~DalNullable();
		DalNullable( const Nullable& );
		DalNullable& operator=( const Nullable& );

		bool nullDefined() const;
		NullType nullType() const;
		void nullValue( long value );
		void nullValue( const std::string& value );
		long intNullValue() const;
		const std::string& stringNullValue() const;
		void deleteNullValue();

	private :
		Nvalue * _nvalue;
		void checkOperation( Nullable::NullType nullType ) const;
};


#endif




