// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
using namespace std;
/*************************************************************** 
* 
* DalVColumnData.cc                  & XMM Science Analysis System (SAS) 
* 
* Class representing data object.
* 
* (c) 2001 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalVColumnData.cc,v 1.2 2004/03/05 14:43:01 eojero Exp $ 
* 
*****************************************************************/ 

#include <Tracer.h>

#include "DalVColumnData.h"


DalVColumnData::DalVColumnData(
	CellData*			cellData )
	  : _data( cellData )
{
	PROC
	ENDPROC
}


DalVColumnData::~DalVColumnData()
{
	PROC
	delete _data;
	ENDPROC
}


Dal::AccessMode
DalVColumnData::mode() const
{
	PROC
	RETURN _data -> mode();
}


int8 *
DalVColumnData::int8Data() const
{
	PROC
	RETURN _data -> int8Data();
}


uint16 *
DalVColumnData::uint16Data() const
{
	PROC
	RETURN _data -> uint16Data();
}


int16 *
DalVColumnData::int16Data() const
{ 
	PROC
	RETURN _data -> int16Data();
}


uint32 *
DalVColumnData::uint32Data() const
{
	PROC
	RETURN _data -> uint32Data();
}


int32 *
DalVColumnData::int32Data() const
{
	PROC
	RETURN _data -> int32Data();
}


real32 *
DalVColumnData::real32Data() const 
{ 
	PROC
	RETURN _data -> real32Data();
}


real64 *
DalVColumnData::real64Data() const 
{ 
	PROC RETURN _data -> real64Data(); 
}


bool8 *
DalVColumnData::boolData() const 
{ 
	PROC
	RETURN _data -> boolData(); 
}


char*
DalVColumnData::stringData() const 
{ 
	PROC
	RETURN _data -> stringData(); 
}


unsigned long DalVColumnData::position(
	unsigned long			/*row*/) const
{
	PROC
	RETURN 0;
}


unsigned long DalVColumnData::position(
		unsigned long			/*row*/,
		unsigned long		 	/*pos*/) const
{
	PROC
	RETURN 0;
}


unsigned long DalVColumnData::position(
		unsigned long			/*row*/,
		const longVec& 	/*pos*/) const
{
	PROC
	RETURN 0;
}


void DalVColumnData::release() 
{ 
	PROC
	_data -> release();
	ENDPROC 
}


bool DalVColumnData::isNull(long unsigned pos ) const 
{ 
	PROC
	RETURN _data -> isNull( pos ); 
}


void DalVColumnData::setToNull(long unsigned pos ) const 
{ 
	PROC
	_data -> setToNull( pos );
	ENDPROC 
}


bool DalVColumnData::hasNulls() const 
{ 
	PROC
	RETURN _data -> hasNulls(); 
}


unsigned int DalVColumnData::dataSize() const 
{ 
	PROC
	RETURN _data -> dataSize(); 
}


unsigned long DalVColumnData::elements() const 
{ 
	PROC
	RETURN _data -> size(); 
}


const longVec& DalVColumnData::size() const 
{ 
	PROC
	RETURN Dal::zero; 
}


Data::DataType DalVColumnData::dataType() const 
{ 
	PROC
	RETURN _data -> dataType(); 
}


void DalVColumnData::printOn( ostream & os, const string & sep) const
{ 
	PROC
	_data -> printOn( os, sep );
	ENDPROC 
}


void DalVColumnData::seek( unsigned long  from, unsigned long count ) 
{ 
	PROC
	_data -> seek( from, count );
	ENDPROC 
}


long unsigned int DalVColumnData::from() const 
{ 
	PROC
	RETURN _data -> from(); 
}


long unsigned int DalVColumnData::count() const 
{ 
	PROC
	RETURN _data -> count(); 
}


Column *
DalVColumnData::parent() 
{ 
	PROC
	RETURN _data -> parent(); 
}


const Column *
DalVColumnData::parent() const 
{ 
	PROC
	RETURN _data -> parent(); 
}


void
DalVColumnData::parent( const Column * parent ) 
{ 
	PROC
	_data -> parent( parent);
	ENDPROC 
}


bool
DalVColumnData::isOrphan() const
{ 
	PROC RETURN _data -> isOrphan(); 
}


