// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.

#ifndef __UTILITIES_H
#define __UTILITIES_H


#include <vector>

template<class T>
class Mvec
{
	public :

		Mvec( const std::vector<T> & vec )
		{
			_mvec = new T[ vec.size() ];
			for( unsigned int i = 0; i < vec.size(); ++i )
			{
				_mvec[ i ] = vec[ i ];
			} // for
		}

		~Mvec() { delete _mvec; }

		operator T* () { return _mvec; }
		T * data() { return _mvec; }

	private :

		T * _mvec;

};

#endif

