// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*************************************************************** 
* 
* MemColumnData.h            & XMM Science Analysis System (SAS) 
* 
* Class representing the Data in a Column. 
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: MemColumnData.h,v 1.2 2004/03/05 14:43:03 eojero Exp $ 
* 
*****************************************************************/ 
#ifndef MEM_COLUMN_DATA
#define MEM_COLUMN_DATA


#include <Dal.h>

#include "MemData.h"
#include "DataStorage.h"
#include "DalColumnData.h"
#include "DalColumn.h"


class MemColumnData : public DalColumnData, public MemData<DalColumn>
{
	public :

		MemColumnData(
			DataStorage *			data,
			const DalColumn *		parent,
			unsigned long			from,
			unsigned long			count,
			AccessMode			accessMode );

		virtual  ~MemColumnData();

    		unsigned long position(
				unsigned long			row) const;

    		unsigned long position(
				unsigned long			row,
				unsigned long		 	pos) const;

    		unsigned long position(
				unsigned long			row,
				const vector<unsigned long>& 	pos) const;

		unsigned long elements() const;
		const vector<unsigned long>& size() const;

		void seek( unsigned long from, unsigned long count );

};


#endif


