// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*************************************************************** 
* 
* MemTable.h             & XMM Science Analysis System (SAS) 
* 
* Class representing DAL data table.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: MemTable.h,v 1.2 2004/03/05 14:43:03 eojero Exp $ 
* 
*****************************************************************/ 
#ifndef MEM_TABLE_H
#define MEM_TABLE_H

#include "Dal.h"
#include "DalTable.h"


class MemTable : public DalTable
{


	public :

		MemTable(
			const std::string &	name,
			unsigned long	rows,
			const std::string &	label,
			DalDataSet *	parent );

		//DalTable * makeTable(
		//	const std::string &	name,
		//	unsigned long	rows,
		//	const std::string &	label,
		//	DalDataSet *	parent );

		MemTable(
			const Table & 	original,
			DalDataSet * 	parent,
			const std::string &	newName = "" );

		virtual ~MemTable();

		DalTable& operator=( const Table& );

		void forEachSubTable( void(*callThisFunction)( Table * table ));

	private :

		// Forbid
		MemTable(const MemTable&);

		DalColumn * makeColumn(
				const std::string &			name,
				Data::DataType			dataType,
				const std::string &			label,
				const std::string &			units,
				const longVec &	size,
				DalTable *			parent );

};


#endif
