// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
using namespace std;
#include<cassert>

#include <Dal.h>
#include <iostream>


int
main()
{
  DataSet* set = dataSetServer->open("test.dat",DataSet::Create);
  set -> addComment( "first comment" );
  set -> addComment( "" );
  set -> addComment( " " );
  set -> addComment( "  " );
  set -> addComment( "   " );
  set -> addComment( "    " );
  set -> addComment( "third comment" );
  set -> addComment( "fourth comment" );
  set -> addComment( "" );
  set -> addComment( "fifth comment" );
  set -> addComment( "sixth comment" );
  assert( set -> comments() == 11 );
  assert( set -> comment( 0 ) == "first comment" );
  assert( set -> comment( 1 ) == "" );
  assert( set -> comment( 2 ) == " " );
  assert( set -> comment( 3 ) == "  " );
  assert( set -> comment( 4 ) == "   " );
  assert( set -> comment( 5 ) == "    " );
  assert( set -> comment( 6 ) == "third comment" );
  assert( set -> comment( 7 ) == "fourth comment" );
  assert( set -> comment( 8 ) == "" );
  assert( set -> comment( 9 ) == "fifth comment" );
  assert( set -> comment( 10 ) == "sixth comment" );
  dataSetServer->close(set);

  set = dataSetServer->open("test.dat",DataSet::Read);
  cout << "no.comments = " << set -> comments() << endl;
  assert( set -> comments() == 11 );
  assert( set -> comment( 0 ) == "first comment" );
  assert( set -> comment( 1 ) == "" );
  assert( set -> comment( 2 ) == "" );
  assert( set -> comment( 3 ) == "" );
  assert( set -> comment( 4 ) == "" );
  assert( set -> comment( 5 ) == "" );
  assert( set -> comment( 6 ) == "third comment" );
  assert( set -> comment( 7 ) == "fourth comment" );
  assert( set -> comment( 8 ) == "" );
  assert( set -> comment( 9 ) == "fifth comment" );
  assert( set -> comment( 10 ) == "sixth comment" );
  dataSetServer->close(set);

  return 0;
}
