! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.

program test

  use dal
  use errorHandling
  implicit none

  type(DataSetT) :: set1, set2
  type(TableT) :: tab1, tab2
  type(ArrayT) :: arr1, arr2

  set1 = dataSet("test1.dat",create)
  call setAttribute(set1,"sbool",.false.,"set bool comment")
  tab1 = addTable(set1,"table",create)
  call setAttribute(tab1,"tint",3,"table int comment")
  call release( set1 );

  set1 = dataSet("test1.dat",read)
  tab1 = table(set1,"table")
  set2 = dataSet("test2.dat",create)
  tab2 = addTable(set2,"table",create)
  call setAttribute( set2, attribute( set1, "sbool" ))
  call setAttribute( set2, attribute( tab1, "tint" ))
  call setAttribute( tab2, attribute( set1, "sbool" ))
  call setAttribute( tab2, attribute( tab1, "tint" ))
  call release( set1 );
  call release( set2 );

  set2 = dataSet("test2.dat",read)
  tab2 = table(set2,"table")
  if ( booleanAttribute(set2,"sbool") ) &
	call error("testFailed","set bool value")
  if ( int16Attribute(set2,"tint") /= 3 ) &
	call error("testFailed","set int value")
  if ( booleanAttribute(tab2,"sbool") ) &
	call error("testFailed","tab bool value")
  if ( int16Attribute(tab2,"tint") /= 3 ) &
	call error("testFailed","tab int value")
  call release( set2 );
 
end program test
