! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
   program test
   
     use dal
     use errorhandling
     implicit none
   
     type(DataSetT) set, set1 
     type(TableT) table2
     type(ColumnT) col
     type(BlockT) blk
     integer, parameter :: nRows = 10
     integer(kind=int32), dimension(:), pointer :: i32
     integer :: i
   
     set = dataSet("test.dat",CREATE)
     call setAttribute(set,"sbool",.false.,"set bool comment")
   
     table2 = addTable(set,"table2",nRows);
     call setAttributes(attributable(table2),attributable(set));
     col = addColumn(table2,"int32",Integer32,units="dm",comment="int32 column")
     i32 => int32Data(col)
     do i=0,nRows-1
       i32(i) = 3*i
     end do
     call release(col)
     col = addColumn(table2,"int32_2",Integer32,units="dm",comment="int32 column")
     i32 => int32Data(col)
     do i=0,nRows-1
       i32(i) = 3*i
     end do
     call release(col)
     col = addColumn(table2,"int32_3",Integer32,units="dm",comment="int32 column")
     i32 => int32Data(col)
     do i=0,nRows-1
       i32(i) = 3*i
     end do
     call release(col)
     call release(table2)
     call release(set)
   
   
   
     set = dataSet("test.dat",READ)
     set1 = dataSet("test1.dat",CREATE)
   
     call addAttributes(attributable(set1),attributable(set))
   
     blk = block(set,"table2",READ)
   
     call copyBlock(set1,blk,"table3")
     call copyBlock(set1,blk,"table4")
   
     call release(set)
     call release(set1)
   
   end program
