! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
program test

  use dal
  use errorhandling

  implicit none

  type(DataSetT) :: set
  type(TableT) :: tab
  type(ColumnT) :: col
  integer(kind=int32), dimension(:), pointer :: x

  integer i

  set = dataSet("test.dat",Create)
  tab = addTable(set,"events",100)
  col = addColumn(tab,"x",Integer32)
  x => int32Data(col)
  do i=0,numberOfRows(tab)-1
    x(i) = i
  end do
  call release(col)

  call copyRows(tab,1,0,3);

  col = column(tab,"x")
  x => int32Data(col);
  write(*,*) x
  if ( x(0) /= 1 ) call error("test","x(0) /= 1")
  if ( x(1) /= 2 ) call error("test","x(1) /= 2")
  if ( x(2) /= 3 ) call error("test","x(2) /= 3")
  if ( x(3) /= 3 ) call error("test","x(3) /= 3")
  if ( x(4) /= 4 ) call error("test","x(4) /= 4")
  call release(col)

  call copyRows(tab,7,3,3)

  col = column(tab,"x")
  x => int32Data(col)
  write(*,*) x
  if ( x(2) /= 3 ) call error("test","copyRows")
  if ( x(3) /= 7 ) call error("test","copyRows")
  if ( x(4) /= 8 ) call error("test","copyRows")
  if ( x(5) /= 9 ) call error("test","copyRows")
  if ( x(6) /= 6 ) call error("test","copyRows")
  call release(col)

  call copyRows(tab,13,6,1)

  col = column(tab,"x")
  x => int32Data(col)
  write(*,*) x
  if ( x(5) /= 9 )  call error("test","copyRows")
  if ( x(6) /= 13 ) call error("test","copyRows")
  if ( x(7) /= 7 )  call error("test","copyRows")
  call release(col)

  call release(set)

end program
