! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
! This subroutine will write the contents of column 'x' to standard output.
module foreachrow1

  use dal
  use errorhandling

contains

  subroutine main()

    ! This part of the program will apply reportX to a table. 
    type(DataSetT) :: set
    type(TableT) :: tab
    type(ColumnT) :: xCol
    real(single), dimension(:), pointer :: x

    set = dataSet("test.dat",CREATE)
    tab = addTable(set,"events",1024)
    xCol = addColumn(tab,"x",real32,"mm")
    x => real32Data(xCol)
    x = 3

    call forEachRow(tab,proc)
  
    call release(tab)
    call release(set)

  end subroutine

  subroutine proc(tab)
    use dal
    use errorhandling

    type(TableT), intent(in) :: tab

    type(ColumnT) :: xCol
    real(kind=single), dimension(:), pointer :: x

    xCol = column(tab,"x",READ)
    x => real32Data(xCol)
    if (x(0) /= 3.0) call error("","wrong value in column")
    write(*,*) x

  end subroutine proc

end module foreachrow1
