! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
program test

  use dal
  use errorhandling

  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ColumnT) col
  type(TableSeekerT) seeker
  integer(kind=int32), dimension(:), pointer :: i32
  integer i

  set = dataSet("test.dat",CREATE)
  tab = addTable(set,"some table",100)
  col = addColumn(tab,"int32",INTEGER32,"cm")

  seeker = newTableSeeker( tab )

  do while( next( seeker ) )
    i32 => int32Data(col)
    !write(*,*) "SEEKER [",from(seeker),count(seeker),"]"
    do i = 0, count( seeker ) - 1
      !write(*,*) "i = ",i
      i32(i) = i
    end do
    call release( col )
  end do

  call release( seeker )
  call release(set)

  set = dataSet("test.dat",READ)
  tab = table(set,"some table")
  col = column(tab,"int32")

  seeker = newTableSeeker( tab )

  do while( next( seeker ) )
    i32 => int32Data(col)
    !write(*,*) "SEEKER [",from(seeker),count(seeker),"]"
    do i = 0, count( seeker ) - 1
      !write(*,*) "i = ",i
      if( i32(i) /= i ) then
        write(errstr,*) "wrong column value"
        call error("internalError")
      endif
    end do
    call release( col )
  end do

  call release( seeker )
  call release( set )

end program test
