! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
program spr1656f90
  use dal

  type(DataSetT) :: set
  type(TableT) :: tab
  type(ColumnT) :: col
  integer i
  character(len = 20)  :: setname
  character(len = 10), parameter :: notpadded =  "0123456"
  character(len = 10), parameter :: padded =  "012345    "

  call setClient("test")
  write(*,*)'padded'
  setname =  "pad_spr1656f90.ds"
  call createit(setname, padded)
  call checkit(setname, padded)
  write(*,*)'not padded'
  setname =  "npad_spr1656f90.ds"
  call createit(setname, notpadded)
  call checkit(setname, notpadded)

contains
  subroutine createit(setname, str)
    use dal

    character(len=*), intent(in) :: setname, str
    type(DataSetT) :: set
    type(TableT) :: tab
    type(ColumnT) :: col
    integer i
    set = dataSet(setname, CREATE)
    tab = addTable(set, "table", 1)
    col = addColumn(tab, "column", STRING, "", (/10/) )
    do i=0,numberOfRows(tab)-1
       call setStringCell(col,i,str)
    end do
    call release(col)
    call release(tab)
    call release(set)
  end subroutine createit

  subroutine checkit(setname, str)
    use dal

    character(len=*), intent(in) :: setname, str
    type(DataSetT) :: set
    type(TableT) :: tab
    type(ColumnT) :: col
    character(len = 10) :: t
    integer i, k
    set = dataSet(setname, READ)
    tab = table(set, "table", 10)
    col = column(tab, "column")
    do i=0,numberOfRows(tab)-1
       t = stringCell( col, i )
       write(*,*)'from ds',len(t), t
       write(*,*)'input', len(str), str
       do k=1, len(t)
          write(*,*)k, t(k:k), str(k:k), iachar(t(k:k)), iachar(str(k:k))
       end do
       if( t .eq. str )then
          write(*,*)'at row', i, 'they are the same'
       else
          write(*,*)'at row', i, 'they are NOT the same'
          exit
       end if
       if( trim(t) .eq. trim(str) )then
          write(*,*)'at row', i, 'they are the same (trim)'
       else
          write(*,*)'at row', i, 'they are NOT the same (trim)'
          exit
       end if
    end do
    call release(col)
    call release(tab)
    call release(set)
  end subroutine checkit
end program spr1656f90
