// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//  Giuseppe Vacanti (cosine science & computing bv)
//  September  9, 2002
// 
//   $Id: spr1883.cc,v 1.3 2009/06/22 15:58:03 rsaxton Exp $
#include <Dal.h>
#include<string>
#include<ExceptionErrorHandler.h>
#include<errstr.h>
#include<iostream>
#include<cassert>
/* AI gcc4 portin
 * exit was not declared in this scope => #include<cstdlib>
 */
#include<cstdlib>
// The test dataset contains TFORM==2 but it also contains TTYPE3. The
// DAL will fail with inconsistentDataSet because it believes the
// dataset to contain 3 columns.

int main() {
    
    ExceptionErrorHandler thrower;
    errHandler.handler(&thrower);
    
    std::string name("spr1883.set");
    DataSet * set = 0;
    try {
	set = dataSetServer->open(name, Dal::Read);
    }
    catch (SasException::Exception e){
	std::cerr << "Failed with message:" << e.message << std::endl;
	assert(e.message.find("The number of columns reported by the TFIELDS attribute is") != std::string::npos);
	exit(0);
    }

    dataSetServer->close(set);
    std::cerr << "Did not fail as expected." << std::endl;
    exit(1);
}
