// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
using namespace std;
//
// XMM Science Analysis System
//
// Giuseppe Vacanti (cosine science & computing) 
// October 2001
//
#include<Dal.h>
#include<string>
#include<ExceptionErrorHandler.h>
#include<errstr.h>
#include<cassert>
/* AI gcc4 porting
 * 'exit' was not declared in this scope => include cstdlib.h
 */
#include <cstdlib>
int main() {

  ExceptionErrorHandler thrower;
  errHandler.handler(&thrower);

  // ds("x.ds") -> Could not find block with qualified name 'x:x' in dataset with name 'x', whereas it should indicate that no table name was given.
  std::string ds("x.ds");
  DataSet * set =  dataSetServer->open(ds, Dal::Create);
  
  try {
    set->table(ds);
  }
  // I rely on a specific string to be in the error message
  catch(SasException::Exception e){
    std::cout << "Failed with " << e.message << std::endl;    
    assert(e.message.find("Most likely you failed to specify append a ':' to") !=
	   std::string::npos);
    std::cout << "Failed as expected with " << e.message << std::endl;    
    exit(0);
  }
  exit(1);

}
    
  
