// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//
// XMM Science Analysis System
//
// Giuseppe Vacanti (cosine science & computing) 
// $Id: spr2343.cc,v 1.2 2004/03/05 14:43:04 eojero Exp $
//
#include<Dal.h>
#include<errstr.h>
#include <ExceptionErrorHandler.h>  
#include<iostream>
#include<Tracer.h>
#include<cmath>
#include<cassert>

int main()
{
    
    // One needs this file to see the problem (pure virtual method called).
    // If one creates a separate file the problem is different. (See below.)
    std::string set1("spr2343.set");
    DataSet * s1;
    Table * t;
 

    unsigned long from = 0;
    unsigned long to = 0;
    unsigned long count = 1;
    
    s1 = dataSetServer->open(set1, Dal::Modify);
    t = s1->table(0);
    t->copyRows(from, to, count);
    
    dataSetServer->close(s1);


    // In general copying rows from from == to corrupts the data
    // because these are overwritten with random garbage.

    set1 = "spr2343bis.ds";

    s1 = dataSetServer->open(set1, Dal::Create);
    t = s1->addTable("table", 1);
    Column * c = t->addColumn("column",Dal::Int16,"","",Dal::zero);
    CellData *d = c->cellData(0);
    d->size(3);
    int16 * v = d->int16Data();
    v[0] = v[1] = v[2] = 3;
    delete d;

    t->copyRows(from, to, count);
    // At this stage any pointers are not guaranteed to be valid.

    dataSetServer->close(s1);
  
    s1 = dataSetServer->open(set1, Dal::Modify);
    t = s1->table(0);

    c = t->column("column");
    d = c->cellData(0);
    v = d->int16Data();


    assert(v[0] == 3 && v[1] == 3 && v[2] == 3);

    dataSetServer->close(s1);

    
}
